"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addKeyword = exports.metaInterpret = exports.interpret = exports.metaCompile = exports.compile = undefined;

var _bluebird = require("bluebird");

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _jsonPointer = require("@hyperjump/json-pointer");

var JsonPointer = _interopRequireWildcard(_jsonPointer);

var _jsonReference = require("@hyperjump/json-reference");

var JsonReference = _interopRequireWildcard(_jsonReference);

var _validationResult = require("./validation-result");

var ValidationResult = _interopRequireWildcard(_validationResult);

var _jsonValidationCommon = require("./json-validation-common");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var compile = exports.compile = function () {
  var _ref = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(doc, ast) {
    var meta;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!(ast[doc.url] === undefined)) {
              _context2.next = 8;
              break;
            }

            ast[doc.url] = false;

            _context2.next = 4;
            return getMeta(doc);

          case 4:
            meta = _context2.sent;
            _context2.next = 7;
            return JsonReference.entries(doc).filter(function (_ref2) {
              var _ref3 = _slicedToArray(_ref2, 2),
                  keyword = _ref3[0],
                  _ = _ref3[1];

              return keyword !== "$meta";
            }).map(function () {
              var _ref4 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref5) {
                var _ref6 = _slicedToArray(_ref5, 2),
                    keyword = _ref6[0],
                    keywordDoc = _ref6[1];

                var keywordUrl, node;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        if (keyword in meta) {
                          _context.next = 2;
                          break;
                        }

                        throw Error("Encountered undeclared keyword '" + keyword + "' at '" + keywordDoc.url + "'");

                      case 2:
                        keywordUrl = meta[keyword];
                        _context.next = 5;
                        return keywords[keywordUrl].compile(keywordDoc, ast);

                      case 5:
                        node = _context.sent;
                        return _context.abrupt("return", [keywordUrl, keywordDoc.url, node]);

                      case 7:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee, undefined);
              }));

              return function (_x3) {
                return _ref4.apply(this, arguments);
              };
            }());

          case 7:
            ast[doc.url] = _context2.sent;

          case 8:
            return _context2.abrupt("return", ast);

          case 9:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function compile(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var metaAst = {};
var metaCompile = exports.metaCompile = function () {
  var _ref7 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(doc) {
    var meta;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return getMeta(doc);

          case 2:
            meta = _context4.sent;
            _context4.next = 5;
            return Promise.all(Object.entries(meta).filter(function (_ref8) {
              var _ref9 = _slicedToArray(_ref8, 2),
                  keyword = _ref9[0],
                  keywordUrl = _ref9[1];

              return keyword[0] !== "$" && !(keywordUrl in metaAst);
            }).map(function () {
              var _ref10 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(_ref11) {
                var _ref12 = _slicedToArray(_ref11, 2),
                    keyword = _ref12[0],
                    _ = _ref12[1];

                var keywordUrl, metaDoc;
                return regeneratorRuntime.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        keywordUrl = meta[keyword];
                        _context3.next = 3;
                        return JsonReference.get(keywordUrl);

                      case 3:
                        metaDoc = _context3.sent;
                        _context3.next = 6;
                        return compile(metaDoc, metaAst);

                      case 6:
                        return _context3.abrupt("return", _context3.sent);

                      case 7:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3, undefined);
              }));

              return function (_x5) {
                return _ref10.apply(this, arguments);
              };
            }()));

          case 5:
            return _context4.abrupt("return", meta);

          case 6:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4, undefined);
  }));

  return function metaCompile(_x4) {
    return _ref7.apply(this, arguments);
  };
}();

var interpret = exports.interpret = function interpret(ast, url) {
  return function (value) {
    return ast[url].map(function (_ref13) {
      var _ref14 = _slicedToArray(_ref13, 3),
          keywordUrl = _ref14[0],
          ptr = _ref14[1],
          keywordValue = _ref14[2];

      var keyword = keywords[keywordUrl];
      var isValid = keyword.type !== undefined && !_jsonValidationCommon.isType[keyword.type](value) || keywords[keywordUrl].interpret(keywordValue, value, ast);

      return [ptr, isValid];
    });
  };
};

var metaInterpret = exports.metaInterpret = function metaInterpret(meta, value) {
  return Object.keys(value).filter(function (keyword) {
    return keyword in meta;
  }).map(function (keyword) {
    var keywordUrl = meta[keyword];
    var result = interpret(metaAst, keywordUrl)(value[keyword]);
    return [JsonPointer.append(JsonPointer.nil, keyword), ValidationResult.isValid(result)];
  });
};

var getMeta = function () {
  var _ref15 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(doc) {
    var $meta;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.prev = 0;
            _context5.next = 3;
            return JsonReference.get("#/$meta", doc);

          case 3:
            $meta = _context5.sent;
            return _context5.abrupt("return", JsonReference.value($meta));

          case 7:
            _context5.prev = 7;
            _context5.t0 = _context5["catch"](0);
            return _context5.abrupt("return", {});

          case 10:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, undefined, [[0, 7]]);
  }));

  return function getMeta(_x6) {
    return _ref15.apply(this, arguments);
  };
}();

var keywords = {};

var addKeyword = exports.addKeyword = function addKeyword(url, keywordDefinition) {
  return keywords[url] = keywordDefinition;
};