"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validate = exports.entries = exports.map = exports.get = exports.pointer = exports.value = exports.nil = undefined;

var _bluebird = require("bluebird");

var _jsonReference = require("@hyperjump/json-reference");

var JsonReference = _interopRequireWildcard(_jsonReference);

var _jsonValidationCore = require("./json-validation-core");

var Core = _interopRequireWildcard(_jsonValidationCore);

var _validationResult = require("./validation-result");

var ValidationResult = _interopRequireWildcard(_validationResult);

var _const = require("./keywords/common/const");

var const_ = _interopRequireWildcard(_const);

var _type = require("./keywords/common/type");

var type = _interopRequireWildcard(_type);

var _multipleOf = require("./keywords/common/multipleOf");

var multipleOf = _interopRequireWildcard(_multipleOf);

var _maximum = require("./keywords/common/maximum");

var maximum = _interopRequireWildcard(_maximum);

var _exclusiveMaximum = require("./keywords/common/exclusiveMaximum");

var exclusiveMaximum = _interopRequireWildcard(_exclusiveMaximum);

var _minimum = require("./keywords/common/minimum");

var minimum = _interopRequireWildcard(_minimum);

var _exclusiveMinimum = require("./keywords/common/exclusiveMinimum");

var exclusiveMinimum = _interopRequireWildcard(_exclusiveMinimum);

var _maxLength = require("./keywords/common/maxLength");

var maxLength = _interopRequireWildcard(_maxLength);

var _minLength = require("./keywords/common/minLength");

var minLength = _interopRequireWildcard(_minLength);

var _pattern = require("./keywords/common/pattern");

var pattern = _interopRequireWildcard(_pattern);

var _items = require("./keywords/common/items");

var items = _interopRequireWildcard(_items);

var _tupleItems = require("./keywords/common/tupleItems");

var tupleItems = _interopRequireWildcard(_tupleItems);

var _maxItems = require("./keywords/common/maxItems");

var maxItems = _interopRequireWildcard(_maxItems);

var _minItems = require("./keywords/common/minItems");

var minItems = _interopRequireWildcard(_minItems);

var _uniqueItems = require("./keywords/common/uniqueItems");

var uniqueItems = _interopRequireWildcard(_uniqueItems);

var _properties = require("./keywords/common/properties");

var properties = _interopRequireWildcard(_properties);

var _patternProperties = require("./keywords/common/patternProperties");

var patternProperties = _interopRequireWildcard(_patternProperties);

var _propertyNames = require("./keywords/common/propertyNames");

var propertyNames = _interopRequireWildcard(_propertyNames);

var _maxProperties = require("./keywords/common/maxProperties");

var maxProperties = _interopRequireWildcard(_maxProperties);

var _minProperties = require("./keywords/common/minProperties");

var minProperties = _interopRequireWildcard(_minProperties);

var _required = require("./keywords/common/required");

var required = _interopRequireWildcard(_required);

var _allOf = require("./keywords/common/allOf");

var allOf = _interopRequireWildcard(_allOf);

var _anyOf = require("./keywords/common/anyOf");

var anyOf = _interopRequireWildcard(_anyOf);

var _oneOf = require("./keywords/common/oneOf");

var oneOf = _interopRequireWildcard(_oneOf);

var _not = require("./keywords/common/not");

var not = _interopRequireWildcard(_not);

var _definitions = require("./keywords/common/definitions");

var definitions = _interopRequireWildcard(_definitions);

var _validation = require("./keywords/common/validation");

var validation = _interopRequireWildcard(_validation);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var nil = exports.nil = JsonReference.nil;
var value = exports.value = JsonReference.value;
var pointer = exports.pointer = JsonReference.pointer;
var get = exports.get = JsonReference.get;
var map = exports.map = JsonReference.map;
var entries = exports.entries = JsonReference.entries;

var validate = exports.validate = function () {
  var _ref = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee(doc) {
    var meta, result, ast;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return Core.metaCompile(doc);

          case 2:
            meta = _context.sent;
            result = Core.metaInterpret(meta, value(doc));

            if (ValidationResult.isValid(result)) {
              _context.next = 6;
              break;
            }

            throw result;

          case 6:
            _context.next = 8;
            return Core.compile(doc, {});

          case 8:
            ast = _context.sent;
            return _context.abrupt("return", Core.interpret(ast, doc.url));

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function validate(_x) {
    return _ref.apply(this, arguments);
  };
}();

Core.addKeyword("http://validation.hyperjump.io/common/const", const_);
Core.addKeyword("http://validation.hyperjump.io/common/type", type);
Core.addKeyword("http://validation.hyperjump.io/common/multipleOf", multipleOf);
Core.addKeyword("http://validation.hyperjump.io/common/maximum", maximum);
Core.addKeyword("http://validation.hyperjump.io/common/exclusiveMaximum", exclusiveMaximum);
Core.addKeyword("http://validation.hyperjump.io/common/minimum", minimum);
Core.addKeyword("http://validation.hyperjump.io/common/exclusiveMinimum", exclusiveMinimum);
Core.addKeyword("http://validation.hyperjump.io/common/maxLength", maxLength);
Core.addKeyword("http://validation.hyperjump.io/common/minLength", minLength);
Core.addKeyword("http://validation.hyperjump.io/common/pattern", pattern);
Core.addKeyword("http://validation.hyperjump.io/common/items", items);
Core.addKeyword("http://validation.hyperjump.io/common/tupleItems", tupleItems);
Core.addKeyword("http://validation.hyperjump.io/common/maxItems", maxItems);
Core.addKeyword("http://validation.hyperjump.io/common/minItems", minItems);
Core.addKeyword("http://validation.hyperjump.io/common/uniqueItems", uniqueItems);
Core.addKeyword("http://validation.hyperjump.io/common/properties", properties);
Core.addKeyword("http://validation.hyperjump.io/common/patternProperties", patternProperties);
Core.addKeyword("http://validation.hyperjump.io/common/propertyNames", propertyNames);
Core.addKeyword("http://validation.hyperjump.io/common/maxProperties", maxProperties);
Core.addKeyword("http://validation.hyperjump.io/common/minProperties", minProperties);
Core.addKeyword("http://validation.hyperjump.io/common/required", required);
Core.addKeyword("http://validation.hyperjump.io/common/allOf", allOf);
Core.addKeyword("http://validation.hyperjump.io/common/anyOf", anyOf);
Core.addKeyword("http://validation.hyperjump.io/common/oneOf", oneOf);
Core.addKeyword("http://validation.hyperjump.io/common/not", not);
Core.addKeyword("http://validation.hyperjump.io/common/definitions", definitions);
Core.addKeyword("http://validation.hyperjump.io/common/validation", validation);